From 348d3752555fe3372650e413024f2adddef66cdd Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 17 2020 16:22:36 +0000
Subject: [PATCH 1438/2232] Merge pull request #481 from dtolnay/svg


Add overview svg
---

diff --git a/book/diagram/.gitignore b/book/diagram/.gitignore
new file mode 100644
index 0000000..81631c6
--- /dev/null
+++ b/book/diagram/.gitignore
@@ -0,0 +1,2 @@
+/bin
+/build
diff --git a/book/diagram/Makefile b/book/diagram/Makefile
new file mode 100644
index 0000000..161da34
--- /dev/null
+++ b/book/diagram/Makefile
@@ -0,0 +1,12 @@
+all: overview.svg
+
+build/bin/svgbob:
+	cargo install --git https://github.com/ivanceras/svgbob --rev df01674c47350665158ececa476e63f51c58a9c7 --root build
+
+%.svg: %.ascii build/bin/svgbob
+	build/bin/svgbob $< > $@
+
+clean:
+	rm -f *.svg
+
+.PHONY: all clean
diff --git a/book/diagram/overview.ascii b/book/diagram/overview.ascii
new file mode 100644
index 0000000..06323ca
--- /dev/null
+++ b/book/diagram/overview.ascii
@@ -0,0 +1,13 @@
+                            .-----------------------------.
+                           |     #[cxx::bridge]  mod       |
+                           | definitions and declarations  |
+                            '--------------+--------------'
+                                           |
+                                           |
+                         "Macro expansion" |  "Code generation"
+                           +---------------+---------------+
+         Safe              |                               |
+    straightforward        v                               v      Straightforward
+       "Rust APIs".----------------. "Hidden C ABI".---------------.  "C++ APIs"
+Rust <----------->| "Rust bindings"|<~~~~~~~~~~~~~>| "C++ bindings"|<-----------> "C++"
+code              '----------------'               '---------------'              code
